/*
 *  FeatureExtractor.java
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *	
 */

import java.io.*;
import java.util.*;

public class FeatureExtractor
{
	private RandomAccessFile email;
	private String data;
	private final int SPAM = 1;
	private final int NSPAM = 2;
	
	public FeatureExtractor(File file)
	{
		String input;
		StringBuffer dataBuf;
		
		try {
			input = null;
			email = new RandomAccessFile(file,"r");
			dataBuf = new StringBuffer();
			while (true) {
				input = email.readLine();
				if (input == null)
					break;
				dataBuf.append(input);
				dataBuf.append("\n");
			}
			data = dataBuf.toString();
			email.close();
		} catch (Exception err) {
			System.err.println("Error: " + err);
			System.exit(-1);
		}
	}
	
	public void extractFeatures(Storage storage, int choice)
	{
		StringTokenizer tokenizer;
		
		tokenizer = new StringTokenizer(data,"\n\t\f\r !@#$%^&*()_+-={}:[];'<>,./`~)\"");
		while (tokenizer.hasMoreTokens()) {
			String token;
			boolean nAllDigit;
			
			nAllDigit = false;
			token = tokenizer.nextToken();
			if (token.length() < 3)
				continue;
			for (int i = 0 ; i < token.length() ; i++) {
				if (!Character.isDigit(token.charAt(i))) {
					nAllDigit = true;
					break;
				}
			}
			if (!nAllDigit)
				continue;
			storage.insertFeature(token,choice);
		}
	}
}
