/*
 *  Storage.java
 *
 *  Author : Ahmed Obied (ahmed.obied@gmail.com)
 *
 */

import java.util.*;

public class Storage 
{
	private Vector<String> spamKeys, nspamKeys, allKeys;
	private Hashtable<String,Integer> spamTable, nspamTable;
	private Hashtable<String,Vector> history;
	private final int SPAM = 1;
	private final int NSPAM = 2;
	
	public Storage()
	{
		allKeys = new Vector<String>();
		spamKeys = new Vector<String>();
		nspamKeys = new Vector<String>();
		spamTable = new Hashtable<String,Integer>();
		nspamTable = new Hashtable<String,Integer>();
		history = new Hashtable<String,Vector>();
	}

	public synchronized int getSize(int choice)
	{
		int size;
		
		size = -1;
		if (choice == SPAM)
			size = spamTable.size();
		else
			if (choice == NSPAM)
				size = nspamTable.size();
		return size;
	}
	
	public synchronized void insertFeature(String feature, int choice) 
	{
		Hashtable<String,Integer> tmpTable;
		Vector<String> tmpVector;
		
		tmpTable = null;
		tmpVector = null;
		if (choice == SPAM) {
			tmpTable = spamTable;
			tmpVector = spamKeys;
		}
		else 
			if (choice == NSPAM) {
				tmpTable = nspamTable;
				tmpVector = nspamKeys;
			}
			else 
				return;
		if (tmpTable.containsKey(feature)) {
			int total;
			
			total = (tmpTable.get(feature)).intValue();
			++total;
			tmpTable.put(feature,new Integer(total));
		} 
		else {
			tmpTable.put(feature,new Integer(1));
			tmpVector.add(feature);
		}
	}
	
	public void compute_proability(int spamTotal, int nonspamTotal)
	{
	
	}
	
	public void display()
	{
		for (int i = 0 ; i < spamKeys.size() ; i++) 
			System.out.println("Feature: " + spamKeys.elementAt(i) + " - " + spamTable.get(spamKeys.elementAt(i)).toString());
	}
}
